new;
library gdr,pgraph;
gdrSet;

data = loadd("cac-dj");

r = packr(LogReturn(data[.,2 3],1));

mu = meanc(r);
vc = vcx(r);

{mu1,mu2,sigma1,sigma2,rho} = cov2D(mu,vc);

nx = 150;
xmin = -0.20;
x1 = seqa(xmin,-2*xmin/nx,nx+1)';
xmin = -0.10;
x2 = seqa(xmin,-2*xmin/nx,nx+1);
pdf = pdfbvn(x1,x2,mu1,mu2,sigma1,sigma2,rho);

c = cdfchii(0.9999999,2);
sym3D = delif(100*r,InCovarianceEllipse2(r[.,1],r[.,2],mu1,mu2,sigma1,sigma2,rho,c));

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  volume(2,2,1.5);
  _pzclr = {0 9, 0.00001 10, 1 11, 50 12, 200 13, 500 0, 1000 9,
            1500 10};
  xtics(-20,20,10,2);
  xlabel("\216CAC 40");
  ylabel("\216Dow Jones");
  ytics(-10,10,5,2);
  ztics(0,800,200,2);
  e = ones(rows(sym3D),1);
  _psym3d = sym3D~e.*(0~11~5~0~7);
  graphprt("-c=1 -cf=stress1.ps");
  surface(100*x1,100*x2,pdf);

