new;
library gdr,pgraph;
gdrSet;

data = loadd("cac-dj");

dates = data[.,1];        /* Date    */
CAC40 = data[.,2];        /* CAC 40  */
DJ = data[.,3];           /* Dow Jones  */

r = ln(data[.,2 3]);
r = r - lag1(r);

data = polyintDates(RegularDates(data,19870101,20001231));
N = rows(data);

r = packr(r);
mu = meanc(r);
sigma = stdc(r);
r = (r - mu') ./ sigma';
_Kernel[1:3] = -6|7|512;
{x,d1,F1,retcode} = Kernel(r[.,1]);
{x,d2,F2,retcode} = Kernel(r[.,2]);


graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pframe = 0; _pnum = 2; _pysci = 5; 
  _pnumht = 0.20; _paxht = 0.22; _ptitlht = 0.25;
  _plwidth = 10; 
  fonts("simplex simgrma");

  setwind(1);
    title("\216CAC 40");
    _pcolor = 10;
    xtics(1,N,372,0);
    ytics(0,7000,1000,2);
    let lab = "1987" "1988" "" "1990" "" "1992" "" "1994" "" "1996" "" "1998" "" "2000";
    asclabel(lab,0);
    xlabel("\216Date");
    xy(seqa(1,1,N),data[.,2]);

  setwind(2);
    title("\216Dow Jones");
    _pcolor = 12;
    ytics(0,12000,2000,2);  
    xy(seqa(1,1,N),data[.,3]);


    _plwidth = 10;
    asclabel(0,0); 
    _pmsgstr = "\202\39\201";
    xlabel("\216Rendement normalise");
    title("");

    _pmsgctl = 6.4~0.25~0.20~0~2~0~6;
  setwind(3);
    _pltype = 6|1|3;
    _pcolor = 12|10|13;
    xtics(-6,6,2,2);
    ytics(0,0.6,0.1,2);
    xy(x,pdfn(x)~d1~d2);

    _pmsgctl = 6.5~0.25~0.20~0~2~0~6;
  setwind(4);
    y = seqa(3,0.01,401);
    e = ones(rows(y),1);
    xtics(3,7,0.5,2)
    ytics(0,0.0035,0.001,2);
    _plegstr = "Distribution normale\000CAC 40\000Dow Jones";
    _plegctl = {2 6 4.25 5};
    _pline = e.*(1~6)~y~e.*0~y~pdfn(y)~e.*(1~0~0);
    xy(x,pdfn(x)~d1~d2);

    graphprt("-c=1 -cf=var11.ps");

  endwind;

