new;
library gdr,pgraph;
gdrSet;

load Prices[251,3] = test1.dat;
S = Prices[.,1];
rS = LogReturn(S,1);
rS = trimr(rS,1,0);

load V[251,1] = test2.dat;
rV = LogReturn(V,1);
rV = trimr(rV,1,0);

S_t = 244;

K = 250;
tau = 1;
ir = 0.05;
sigma_t = 0.23;
C_t = EuropeanBS(S_t,K,sigma_t,tau,ir);

theta1 = -1;
theta2 = 10;
P_t = theta1*S_t + theta2*C_t;

S_tp1 = S_t .* (1+rS);
C_tp1 = EuropeanBS(S_tp1,K,sigma_t,tau-1/365,ir);
P_tp1 = theta1*S_tp1 + theta2*C_tp1;
PnL = P_tp1 - P_t; 

VaR = -quantile(PnL,0.01);
print VaR;

S_tp1 = S_t .* (1+rS);
sigma_tp1 = sigma_t .* (1+rV);
C_tp1 = EuropeanBS(S_tp1,K,sigma_tp1,tau-1/365,ir);
P_tp1 = theta1*S_tp1 + theta2*C_tp1;
PnL2 = P_tp1 - P_t; 

VaR = -quantile(PnL2,0.01);
print VaR;

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(3,2.5,0.5,4.3,1);

  setwind(1);
    fonts("simplex simgrma");
    _pcross = 1; _pframe = 0; _pnum = 2; _pdate = 0;
    _pstype = 11; _plctrl = -1; _pcolor = 12;
    ylabel("\216PnL (facteur S)");
    xlabel("\216PnL (facteurs S et \202s\201)");
    xtics(-80,80,20,2);
    ytics(-80,80,20,2);
    xy(PnL2,PnL);

  setwind(2);

    _paxht = 0.30; _pnumht = 0.20; _pcross = 0; _pbox = 15;
    _plwidth = 10; _plctrl = 0;
    xtics(0,250,50,5);
    ytics(0.20,0.45,0.05,2);
    xlabel("\216Temps");
    ylabel("\216Volatilite");
    _pmsgstr = "\202\39\201";
    _pmsgctl = 0.395~4.53~0.20~90~2~0~5;
    _pcolor = 12;
    xy(seqa(1,1,rows(V)),V[.,1]);

    graphprt("-c=1 -cf=var18.ps");

  endwind;
