new;
library gdr,pgraph;
gdrSet;

let year = 1 5 10;
declare matrix corr1,corr2,corr3;

rating1 = "A" | "A" | "BB" | "CCC";
rating2 = "AA" | "BB" | "B" | "CCC";
indx1 = 9-RatingMapping(rating1,0);
indx2 = 9-RatingMapping(rating2,0);
rho = seqa(-1+1/100,1/100,190);

k = 1;
do until k > rows(year);
  SetTransitionMatrix(1);
  TM = ComputePdfMigration(0,0,year[k],0); 
  p = zeros(rows(rho),rows(rating1));
  p1 = zeros(1,rows(rating1));
  p2 = zeros(1,rows(rating1));

  i = 1;
  do until i > rows(rating1);
    j = 1;
    do until j > rows(rho);
      p[j,i] = ComputePdfMigration2(0,rating1[i],rating2[i],year[k],"D","D",rho[j]);
      p1[i] = TM[indx1[i],8];
      p2[i] = TM[indx2[i],8];
      j = j + 1;
    endo;
  i = i + 1;
  endo;
  call varput(OddsRatio(p,p1,p2),"corr" $+ ftos(k,"%lf",1,0));
  k = k + 1;
endo;

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pnumht = 0.20; _paxht = 0.25; _ptitlht = 0.30;
  _pltype = 6|1|3; _plwidth = 10; _pcolor = 10|12|9;
 
  fonts("simplex simgrma");
  xlabel("\216\202r\201");
  xtics(-1,1,0.5,2);
  ytics(0,5,1,0); 

  i = 1;
  do until i > 3;
    setwind(i);
      title("\216" $+ rating1[i] $+ " / " $+ rating2[i]);
      xy(rho,corr1[.,i]~corr2[.,i]~corr3[.,i]);
    i = i + 1;
  endo;

  setwind(i);
    title("\218" $+ rating1[i] $+ " / " $+ rating2[i]);
    _plegstr = "1 an\0005 ans\00010 ans";
    _plegctl = {2 6 2 3};
    xy(rho,corr1[.,i]~corr2[.,i]~corr3[.,i]);

  graphprt("-c=1 -cf=agreg29.ps");

  endwind;

