new;
library gdr,pgraph;
gdrSet;

let r = 0.0 0.1  0.2 0.25 0.3  0.4 0.5 0.6  0.7 0.75 0.8  0.9 1.0;
let p = 0.1 0.2  1.2 2.50 1.2  0.2 0.1 0.2  1.2 2.50 1.2  0.2 0.1;
p = p / sumc(p);
mu = sumc(p .* r);
sigma = sqrt( sumc(p .* (r-mu)^2) );

x = 0|0.001|seqa(0.01,0.01,99)|0.999|1;

{a,b} = calibrateBeta(mu,sigma);
y = pdfbeta(x,a,b);

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(9,6.855,0,0,1);

  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6; _plwidth = 10; _pcolor = 12;
  _pbarwid = 0.35; _pbartyp = 6~9;

  setwind(1);
    xlabel("\216R");
    ytics(0,0.25,0.05,10);
    xtics(-0.1,1.1,0.1,10);
    _pmsgstr = "\201^\000\202\39\201";
    _pmsgctl = 7.44~5.20~0.13~0~2~0~0 |
               8.445~5.2~0.14~0~2~0~0 ;
    bar(r,p);

  setwind(2);
    _plegstr = "Beta calibree";
    _plegctl = {2 5 6.5 5};
    xy(x,y/7.5);

    graphprt("-c=1 -cf=param17.ps");

  endwind;
